//------------------------------------------------------------------------------
// container.c - содержит функции обработки контейнера
//------------------------------------------------------------------------------

#include "container.h"

//------------------------------------------------------------------------------
// Инициализация контейнера
void InitContainer(container *c) {
    c->len = 0;
}

//------------------------------------------------------------------------------
// Очистка контейнера от элементов (освобождение памяти)
void ClearContainer(container *c) {
    c->len = 0;
}

//------------------------------------------------------------------------------
// Ввод содержимого контейнера из указанного потока
void InContainer(container *c, FILE *ifst) {
    while(!feof(ifst)) {
        if(InShape(&((c->cont)[c->len]), ifst)) {
            c->len++;
        }
    }
}

//------------------------------------------------------------------------------
// Случайный ввод содержимого контейнера
void InRndContainer(container *c, int size) {
    while(c->len < size) {
        if(InRndShape(&((c->cont)[c->len]))) {
            c->len++;
        }
    }
}

//------------------------------------------------------------------------------
// Вывод содержимого контейнера в указанный поток
void OutContainer(container *c, FILE *ofst) {
    fprintf(ofst, "Container contains %d elements.\n", c->len);
    for(int i = 0; i < c->len; i++) {
        fprintf(ofst, "%d: ", i);
        OutShape(&(c->cont)[i], ofst);
    }
}

//------------------------------------------------------------------------------
// Вычисление суммы периметров всех фигур в контейнере
double PerimeterSumContainer(container *c) {
    double sum = 0.0;
    for(int i = 0; i < c->len; i++) {
        sum += PerimeterShape(&(c->cont)[i]);
    }
    return sum;
}
