#ifndef __container__
#define __container__

//------------------------------------------------------------------------------
// container.h - содержит тип данных,
// представляющий простейший контейнер
//------------------------------------------------------------------------------

#include "shape.h"

enum {max_len = 10000}; // максимальная длина

//------------------------------------------------------------------------------
// Простейший контейнер на основе одномерного массива
typedef struct container {
    int len; // текущая длина
    shape cont[max_len];
} container;

// Инициализация контейнера
void InitContainer(container *c);

// Очистка контейнера от элементов (освобождение памяти)
void ClearContainer(container *c);

// Ввод содержимого контейнера из указанного потока
void InContainer(container *c, FILE *ifst);

// Случайный ввод содержимого контейнера
void InRndContainer(container *c, int size);

// Вывод содержимого контейнера в указанный поток
void OutContainer(container *c, FILE *ofst);

// Вычисление суммы периметров всех фигур в контейнере
double PerimeterSumContainer(container *c);

#endif
