//------------------------------------------------------------------------------
// shape.cpp - содержит процедуры связанные с обработкой обобщенной фигуры
// и создания произвольной фигуры
//------------------------------------------------------------------------------

#include "shape.h"

//------------------------------------------------------------------------------
// Ввод параметров обобщенной фигуры из файла
bool InShape(shape *s, FILE *ifst) {
    int k;
    fscanf(ifst, "%d", &k);
    switch(k) {
        case 1:
            s->k = RECTANGLE;
            InRectangle(&(s->r), ifst);
            return true;
        case 2:
            s->k = TRIANGLE;
            InTriangle(&(s->t), ifst);
            return true;
        default:
            return false;
    }
}

// Случайный ввод обобщенной фигуры
bool InRndShape(shape *s) {
    int k = rand() % 2 + 1;
    switch(k) {
        case 1:
            s->k = RECTANGLE;
            InRndRectangle(&(s->r));
            return true;
        case 2:
            s->k = TRIANGLE;
            InRndTriangle(&(s->t));
            return true;
        default:
            return false;
    }
}

//------------------------------------------------------------------------------
// Вывод параметров текущей фигуры в поток
void OutShape(shape *s, FILE *ofst) {
    switch(s->k) {
        case RECTANGLE:
            OutRectangle(&(s->r), ofst);
            break;
        case TRIANGLE:
            OutTriangle(&(s->t), ofst);
            break;
        default:
            fprintf(ofst, "Incorrect figure!\n");
    }
}

//------------------------------------------------------------------------------
// Вычисление периметра фигуры
double PerimeterShape(shape *s) {
    switch(s->k) {
        case RECTANGLE:
            return PerimeterRectangle(&(s->r));
            break;
        case TRIANGLE:
            return PerimeterTriangle(&(s->t));
            break;
        default:
            return 0.0;
    }
}
