#ifndef __shape__
#define __shape__

//------------------------------------------------------------------------------
// shape.h - содержит описание обобщающей геометрической фигуры,
//------------------------------------------------------------------------------
#include <stdbool.h>

#include "rectangle.h"
#include "triangle.h"

//------------------------------------------------------------------------------
// значения ключей для каждой из фигур
typedef enum key {RECTANGLE, TRIANGLE} key;

//------------------------------------------------------------------------------
// структура, обобщающая все имеющиеся фигуры
typedef struct shape {
    key k; // ключ
    // используемые альтернативы
    union { // используем простейшую реализацию
        rectangle r;
        triangle t;
    };
} shape;

// Ввод обобщенной фигуры
bool InShape(shape *s, FILE *ifdt);

// Случайный ввод обобщенной фигуры
bool InRndShape(shape *s);

// Вывод обобщенной фигуры
void OutShape(shape *s, FILE *ofst);

// Вычисление периметра обобщенной фигуры
double PerimeterShape(shape *s);

#endif
